//vogelBox3

$fn = 64;
ratio = 1.62;

include <../../libraries/camferCube.scad>
include <../../libraries/screwShapes1.scad>
include <../../libraries/solidShapes.scad>

include <./VogelBoxTrays2.scad>

boxWidth = 80.0;
boxLength = boxWidth; 
boxHeight = 33.0;
boxWall = 2.0;

insideWidth = boxWidth - 2 * boxWall;
insideLength = boxLength - 2 * boxWall;
insideHeight = boxHeight - boxWall + 0.01;

speakerHoleDiam = 46.0;
speakerXoffset = boxWidth / 2; // - 2.5;
speakerYoffset = boxLength / 2; // - 17;
speakerRimDiam = 50.0;
speakerRimRidge = 2.0;

speakerStudHoleD = 6.0;
speakerStudHoleH = 4.0;
speakerScrewHoleD = 2.7;
speakerStudOffset = 20.0;
speakerStudRingH = 2.0;
speakerStudRingHoleD = 3.2;

wallYoffset = 90;

pillarDiam = 6.0;
pillarHoleDepth = 15.0;
pillarHoleDiam = 2.7;
pillarWallOffset = pillarDiam - 1.5;

sdCardWidth = 13.0;
sdCardHeight = 2.0;
sdCardCutoutWidth = sdCardWidth + 1.0;
sdCardCutoutHeight = sdCardHeight + 5.0;

box();
//translate([0, 0, 50]) mirror([0, 0, 1]) boxLid();
//speakerKeeper();
//sdCardCutout();

trayXoffset = boxWidth / 2 + mp3tfTrayWidth / 2;
//translate([trayXoffset, boxWall, 48]) rotate([0, 180, 0]) pMicroTray();
//translate([trayXoffset, boxWall, 48]) rotate([0, 180, 0]) nanoTray();
// translate([boxWidth/2, 0, 45]) color("red") cube([mp3tfTrayWidth, 5, 5], true);  // test

//color("lightblue") panel(boxWall);


module halfBox() {
    difference() {
        camferHalfCube([boxWidth, boxLength, boxHeight]);
        translate([boxWall, boxWall, boxWall]) camferHalfCube([insideWidth, insideLength, insideHeight]);
    }
}

module boxLid() {
    difference() {
        camferHalfCube([boxWidth, boxLength, boxWall]);
        
        translate([pillarWallOffset, pillarWallOffset, -0.02]) flatHeadM3(10);
        translate([boxWidth - pillarWallOffset, pillarWallOffset, -0.02]) flatHeadM3(10);
        
        translate([pillarWallOffset, boxLength - pillarWallOffset, -0.02]) flatHeadM3(10);
        translate([boxWidth - pillarWallOffset, boxLength - pillarWallOffset, -0.02]) flatHeadM3(10);
    }
 }
//            translate([0, 0, 00]) panelCutout();
module box() {
    difference() {
        halfBox();
        // speaker hole
        translate([speakerXoffset, speakerYoffset, -0.02]) 
            cylinder(d1 = speakerHoleDiam + speakerRimRidge * 2, d2 = speakerHoleDiam, h = boxWall + 0.03);
        // control panel cutout
        translate([boxWidth / 2, boxWall - 0.01, boxHeight - panelHeight/2]) {
            rotate([0, 180, 0]) panelCutout();
//            cube([mp3tfTrayWidth, boxWall + 0.02, panelHeight]);
        }
    }
    
    // speakerRim & studs
    translate([speakerXoffset, speakerYoffset, boxWall]) {
        speakerRim();
        translate([-speakerStudOffset, -speakerStudOffset, 0]) speakerStud();
        translate([-speakerStudOffset,  speakerStudOffset, 0]) speakerStud();
        translate([ speakerStudOffset, -speakerStudOffset, 0]) speakerStud();
        translate([ speakerStudOffset,  speakerStudOffset, 0]) speakerStud();
    }
    
    // pillars
    translate([pillarWallOffset, pillarWallOffset, boxWall]) pillar();
    translate([boxWidth - pillarWallOffset, pillarWallOffset, boxWall]) pillar();

    translate([pillarWallOffset, boxLength - pillarWallOffset, boxWall]) pillar();
    translate([boxWidth - pillarWallOffset, boxLength - pillarWallOffset, boxWall]) pillar();
}

module panelCutout() {
    translate([0, 0, -0.1]) rotate([90, 0, 0]) {
/*        pyramid(mp3tfTrayWidth/2, panelHeight/2, 0, 
                mp3tfTrayWidth/2 - boxWall/2, panelHeight/2 - boxWall/2, boxWall/2);
        translate([0, 0, -boxWall/2]) 
            pyramid(mp3tfTrayWidth/2 - boxWall/2, panelHeight/2 - boxWall/2, 0, 
            mp3tfTrayWidth/2, panelHeight/2, boxWall/2); */
        panelBase(mp3tfTrayWidth, panelHeight, boxWall, 0);
    }
}


module pillar() {
    difference() {
        cylinder(d = pillarDiam, h = insideHeight);
        translate([0, 0, insideHeight - pillarHoleDepth + 0.01]) cylinder(d = pillarHoleDiam, h = pillarHoleDepth + 0.01);
    }
}

module speakerRim() {
    difference() {
        cylinder(d = speakerRimDiam + speakerRimRidge * 2, h = speakerRimRidge * 2);
        translate([0, 0, -0.01]) cylinder(d = speakerRimDiam, h = speakerRimRidge * 2 + 0.02);
    }
}

module speakerStud() {
    difference() {
        cylinder(d = speakerStudHoleD, h = speakerStudHoleH);
        translate([0, 0, -0.01]) cylinder(d = speakerScrewHoleD, h = speakerStudHoleH + 0.02);
    }
}

module speakerKeeper() {
    magnetDiam = 22.0;
    magnetRingWidth = 2.0;
    magnetRingHeight = magnetRingWidth;
    difference() {
        cylinder(d = magnetDiam + magnetRingWidth * 2, h = magnetRingHeight);
        translate([0, 0, -0.01]) cylinder(d = magnetDiam, h = magnetRingHeight + 0.02);
    }
    //
    translate([-speakerStudOffset, -speakerStudOffset, 0]) studRing();
    translate([-speakerStudOffset,  speakerStudOffset, 0]) studRing();
    translate([ speakerStudOffset, -speakerStudOffset, 0]) studRing();
    translate([ speakerStudOffset,  speakerStudOffset, 0]) studRing();
    //
    rotate([0, 0, 45]) translate([magnetDiam / 2, -magnetRingWidth / 2, 0]) 
        cube([speakerStudOffset - 4.5, magnetRingWidth, magnetRingHeight]);
    rotate([0, 0, -45]) translate([magnetDiam / 2, -magnetRingWidth / 2, 0]) 
        cube([speakerStudOffset - 4.5, magnetRingWidth, magnetRingHeight]);
    rotate([0, 0, 135]) translate([magnetDiam / 2, -magnetRingWidth / 2, 0]) 
        cube([speakerStudOffset - 4.5, magnetRingWidth, magnetRingHeight]);
    rotate([0, 0, -135]) translate([magnetDiam / 2, -magnetRingWidth / 2, 0]) 
        cube([speakerStudOffset - 4.5, magnetRingWidth, magnetRingHeight]);
}

module studRing() {
   difference() {
        cylinder(d = speakerStudHoleD, h = speakerStudRingH);
        translate([0, 0, -0.01]) cylinder(d = speakerStudRingHoleD, h = speakerStudRingH + 0.02);
    } 
}

module sdCardCutout() {
    cutoutCornerR = 3.0;
    hull() {
        translate([-sdCardCutoutWidth / 2, -sdCardCutoutHeight / 2, 0]) 
            cylinder(d1 = cutoutCornerR, d2 = 0.01, h = boxWall / 2);
        translate([-sdCardCutoutWidth / 2,  sdCardCutoutHeight / 2, 0]) 
            cylinder(d1 = cutoutCornerR, d2 = 0.01, h = boxWall / 2);
        translate([ sdCardCutoutWidth / 2, -sdCardCutoutHeight / 2, 0]) 
            cylinder(d1 = cutoutCornerR, d2 = 0.01, h = boxWall / 2);
        translate([ sdCardCutoutWidth / 2,  sdCardCutoutHeight / 2, 0]) 
            cylinder(d1 = cutoutCornerR, d2 = 0.01, h = boxWall / 2);
    }
}

